> ## Documentation Index
> Fetch the complete documentation index at: https://veryfront.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get agent capabilities

> Get agent capabilities. Requires project.agents.read.



## OpenAPI

````yaml /cloud/rest/openapi.json get /projects/{project_reference}/agents/{agent_id}/capabilities
openapi: 3.1.0
info:
  title: Veryfront REST API reference
  version: 1.0.0
  description: |-
    ## Explore the API

    | Domain | Use it to |
    | --- | --- |
    | [Projects](#tag/projects) | Manage projects and files. |
    | [Agents](#tag/agents) | Manage agent primitives. |
    | [Orchestration](#tag/execution) | Manage conversations and runs. |
    | [Evaluations](#tag/evaluations) | Manage evaluations and results. |
    | [AI Gateway](#tag/ai-gateway) | Access models and inference. |
    | [MCP](#tag/mcp) | Discover tools and authorization. |
    | [Integrations](#tag/integrations) | Manage connections and integrations. |
    | [Knowledge](#tag/knowledge) | Manage documents and search. |
    | [Deployments](#tag/deployments) | Manage releases and deployments. |
    | [Runtime](#tag/runtime) | Manage environments and infrastructure. |
    | [Observability](#tag/observability) | Monitor activity and performance. |
    | [Identity & Access](#tag/identity-access) | Manage identity and access. |
    | [Billing & Usage](#tag/billing-usage) | Manage billing and usage. |
    | [Other](#tag/platform) | Inspect health and API metadata. |

    [OpenAPI specification (JSON)](/openapi.json)
  contact:
    name: Veryfront API Support
    url: https://veryfront.com/docs
    email: support@veryfront.com
  x-api-id: 5f1f0b8a-6b0e-4c1a-9b35-0f3a1e6d84c7
  x-audience: external-public
servers:
  - url: https://api.veryfront.com
security:
  - bearerAuth: []
  - apiKeyAuth: []
tags:
  - name: projects
    description: Manage projects and files.
  - name: agents
    description: Manage agent primitives.
  - name: execution
    description: Manage conversations and runs.
  - name: evaluations
    description: Manage evaluations and results.
  - name: ai-gateway
    description: Access models and inference.
  - name: mcp
    description: Discover tools and authorization.
  - name: integrations
    description: Manage connections and integrations.
  - name: knowledge
    description: Manage documents and search.
  - name: deployments
    description: Manage releases and deployments.
  - name: runtime
    description: Manage environments and infrastructure.
  - name: observability
    description: Monitor activity and performance.
  - name: identity-access
    description: Manage identity and access.
  - name: billing-usage
    description: Manage billing and usage.
  - name: platform
    description: Inspect health and API metadata.
  - name: projects/Projects
  - name: projects/Projects/Favorites
  - name: projects/Projects/Account Projects
  - name: projects/Projects/Projects
  - name: projects/Projects/Project Labels
  - name: projects/Projects/Project templates
  - name: projects/Files
  - name: projects/Files/Files
  - name: projects/Files/File Chunks
  - name: projects/Files/Branch File Versions
  - name: projects/Files/Branch Files
  - name: projects/Files/Environment Files
  - name: projects/Files/File Versions
  - name: projects/Files/Branch File Drafts
  - name: projects/Files/Release Files
  - name: projects/Files/Sandbox Files
  - name: projects/Files/File Search
  - name: projects/Branches
  - name: projects/Branches/Branches
  - name: projects/Branches/Branch Policies
  - name: projects/Branches/Branch Approvals
  - name: projects/Branches/Branch Status Checks
  - name: projects/Branches/Project Commits
  - name: projects/Branches/Branch Merges
  - name: projects/Uploads
  - name: projects/Uploads/Upload Folders
  - name: projects/Uploads/Upload Grants
  - name: projects/Uploads/Project Uploads
  - name: projects/Uploads/Upload Visibility
  - name: agents/Agents
  - name: agents/Agents/Agents
  - name: agents/Agents/Agent Labels
  - name: agents/Agents/Agent templates
  - name: agents/Agents/Agent Tool References
  - name: agents/Agents/Agent Avatars
  - name: agents/Agents/Agent Capabilities
  - name: agents/Agents/Agent Installation
  - name: agents/Prompts
  - name: agents/Prompts/Project prompts
  - name: agents/Tools
  - name: agents/Tools/Project tools
  - name: agents/Skills
  - name: agents/Skills/Project skills
  - name: agents/Resources
  - name: agents/Resources/Project resources
  - name: agents/Tasks
  - name: agents/Tasks/Tasks
  - name: agents/Workflows
  - name: agents/Workflows/Workflows
  - name: execution/Conversations
  - name: execution/Conversations/Conversations
  - name: execution/Conversations/Conversation messages
  - name: execution/Conversations/Conversation participants
  - name: execution/Conversations/Conversation read state
  - name: execution/Triggers
  - name: execution/Triggers/Project schedules
  - name: execution/Triggers/Webhooks
  - name: execution/Triggers/Webhook events
  - name: execution/Runs
  - name: execution/Runs/Run Input Requests
  - name: execution/Runs/Runs
  - name: execution/Runs/Runtime
  - name: execution/Runs/Child Runs
  - name: execution/Runs/Conversation Runs
  - name: execution/Runs/Project Runs
  - name: execution/Runs/Webhook Runs
  - name: execution/Runs/Run Events
  - name: execution/Runs/Run Actions
  - name: execution/Runs/Run Artifacts
  - name: execution/Executors
  - name: execution/Executors/Connected agents
  - name: execution/Executors/Agent workers
  - name: evaluations/Evaluations
  - name: evaluations/Evaluations/Evaluations
  - name: evaluations/Evaluations/Evaluation Runs
  - name: ai-gateway/Models
  - name: ai-gateway/Models/Model discovery
  - name: ai-gateway/Models/Inference Models
  - name: ai-gateway/Models/Project inference policy
  - name: ai-gateway/Models/Account inference policy
  - name: ai-gateway/Inference
  - name: ai-gateway/Inference/OpenAI Chat Completions
  - name: ai-gateway/Inference/Embeddings
  - name: ai-gateway/Inference/OpenAI Responses
  - name: ai-gateway/Inference/Proxy metadata
  - name: ai-gateway/Inference/Anthropic Messages
  - name: ai-gateway/Inference/Provider gateway
  - name: ai-gateway/Inference/Gemini inference
  - name: ai-gateway/Inference/Image generation
  - name: mcp/Tools
  - name: mcp/Tools/MCP discovery
  - name: mcp/Authorization
  - name: mcp/Authorization/Protected resource discovery
  - name: integrations/Integrations
  - name: integrations/Integrations/Integration tools
  - name: integrations/Integrations/Integration catalog
  - name: integrations/Integrations/Project integrations
  - name: integrations/Connections
  - name: integrations/Connections/Connections
  - name: integrations/Channels
  - name: integrations/Channels/Channels
  - name: integrations/Channels/Setup lookups
  - name: integrations/External storage
  - name: integrations/External storage/External Files
  - name: knowledge/Documents
  - name: knowledge/Documents/Project knowledge
  - name: knowledge/Documents/Retrieval documents
  - name: knowledge/Search
  - name: knowledge/Search/Search
  - name: knowledge/Embeddings
  - name: knowledge/Embeddings/Project embeddings
  - name: deployments/Releases
  - name: deployments/Releases/Releases
  - name: deployments/Releases/Release Versions
  - name: deployments/Releases/Release Source Manifests
  - name: deployments/Deployments
  - name: deployments/Deployments/Project deployments
  - name: deployments/Artifacts
  - name: deployments/Artifacts/Dependencies
  - name: deployments/Artifacts/Release Asset Manifests
  - name: deployments/Artifacts/Style artifacts
  - name: runtime/Environments
  - name: runtime/Environments/Environments
  - name: runtime/Environments/Environment Domains
  - name: runtime/Environments/Environment variables
  - name: runtime/Environments/Project Domains
  - name: runtime/Environments/Environment Variable Keys
  - name: runtime/Servers
  - name: runtime/Servers/Environment Servers
  - name: runtime/Servers/Project servers
  - name: runtime/Sandboxes
  - name: runtime/Sandboxes/Sandbox Lifecycle
  - name: runtime/Sandboxes/Sandbox Commands
  - name: runtime/Sandboxes/Sandbox Environment
  - name: runtime/Sandboxes/Sandbox Health
  - name: runtime/Sandboxes/Sandbox Terminal
  - name: runtime/Cache
  - name: runtime/Cache/Project Cache
  - name: runtime/Cache/User Cache
  - name: observability/Logs
  - name: observability/Logs/Log entries
  - name: observability/Traces
  - name: observability/Traces/Trace spans
  - name: observability/Traces/Project traces
  - name: observability/Traces/Trace Search
  - name: observability/Metrics
  - name: observability/Metrics/Metric series
  - name: observability/Alerts
  - name: observability/Alerts/Project alerts
  - name: observability/Error types
  - name: observability/Error types/Error types
  - name: identity-access/Users
  - name: identity-access/Users/Account users
  - name: identity-access/Users/Project users
  - name: identity-access/Users/Current user
  - name: identity-access/Accounts
  - name: identity-access/Accounts/Accounts
  - name: identity-access/Invitations
  - name: identity-access/Invitations/Invitations
  - name: identity-access/Permissions
  - name: identity-access/Permissions/Feature gates
  - name: identity-access/Permissions/Project Ownership
  - name: identity-access/API keys
  - name: identity-access/API keys/API keys
  - name: identity-access/Authentication
  - name: identity-access/Authentication/Sign-in
  - name: identity-access/Authentication/Tokens
  - name: identity-access/Authorization
  - name: identity-access/Authorization/Authorized apps
  - name: identity-access/Authorization/General OAuth
  - name: identity-access/Authorization/Consent
  - name: billing-usage/Subscriptions
  - name: billing-usage/Subscriptions/Subscriptions
  - name: billing-usage/Subscriptions/Seats
  - name: billing-usage/Billing
  - name: billing-usage/Billing/Invoices
  - name: billing-usage/Billing/Payments
  - name: billing-usage/Billing/Payment Methods
  - name: billing-usage/Billing/Billing Details
  - name: billing-usage/Billing/Account billing
  - name: billing-usage/Credits
  - name: billing-usage/Credits/Credits
  - name: billing-usage/Budgets
  - name: billing-usage/Budgets/Budgets
  - name: billing-usage/Usage
  - name: billing-usage/Usage/API key usage
  - name: billing-usage/Usage/Account usage
  - name: billing-usage/Usage/Project usage
  - name: billing-usage/Analytics
  - name: billing-usage/Analytics/Conversation Analytics
  - name: billing-usage/Analytics/Run Analytics
  - name: platform/Other
  - name: platform/Other/API metadata
paths:
  /projects/{project_reference}/agents/{agent_id}/capabilities:
    get:
      tags:
        - agents/Agents/Agent Capabilities
      summary: Get agent capabilities
      description: Get agent capabilities. Requires project.agents.read.
      operationId: getAgentCapabilities
      parameters:
        - $ref: '#/components/parameters/ProjectReference'
        - schema:
            type: string
            description: Agent identifier
          required: true
          name: agent_id
          in: path
        - schema:
            type:
              - string
              - 'null'
            enum:
              - main_branch
              - environment
              - preview_branch
              - null
          required: false
          name: runtime_target_kind
          in: query
        - schema:
            type:
              - string
              - 'null'
            format: uuid
          required: false
          name: target_environment_id
          in: query
        - schema:
            type:
              - string
              - 'null'
            format: uuid
          required: false
          name: target_branch_id
          in: query
        - schema:
            type: string
            enum:
              - project
              - main_branch
              - environment
              - preview_branch
          required: false
          name: source_target_kind
          in: query
      responses:
        '200':
          description: Resolved agent capabilities
          content:
            application/json:
              schema:
                type: object
                properties:
                  agent:
                    type: object
                    properties:
                      id:
                        type: string
                      name:
                        type: string
                      description:
                        type:
                          - string
                          - 'null'
                      provider:
                        type: object
                        properties:
                          organization:
                            type: string
                          url:
                            type: string
                        required:
                          - organization
                          - url
                      version:
                        type: string
                      capabilities:
                        type: object
                        properties:
                          streaming:
                            type: boolean
                          push_notifications:
                            type: boolean
                          extensions:
                            type: array
                            items:
                              type: string
                        required:
                          - streaming
                          - push_notifications
                          - extensions
                      default_input_modes:
                        type: array
                        items:
                          type: string
                      default_output_modes:
                        type: array
                        items:
                          type: string
                      tools:
                        type: array
                        items:
                          type: string
                      skills:
                        type: array
                        items:
                          type: object
                          properties:
                            id:
                              type: string
                            name:
                              type: string
                            description:
                              type: string
                            tags:
                              type: array
                              items:
                                type: string
                            examples:
                              type: array
                              items:
                                type: string
                          required:
                            - id
                            - name
                      suggestions:
                        type: array
                        items:
                          anyOf:
                            - type: string
                              minLength: 1
                            - type: object
                              properties:
                                title:
                                  type: string
                                  minLength: 1
                                prompt:
                                  type: string
                                  minLength: 1
                              required:
                                - title
                                - prompt
                              additionalProperties: false
                      kind:
                        type: string
                        enum:
                          - source_project_agent
                          - installed_project_agent
                      can_run:
                        type: boolean
                      source_type:
                        type: string
                        enum:
                          - project
                          - catalog_install
                      installed_access:
                        type: object
                        properties:
                          grant_id:
                            type: string
                            format: uuid
                          relation:
                            type: string
                            enum:
                              - owner
                              - admin
                              - editor
                              - viewer
                          service_account_id:
                            type: string
                            format: uuid
                          project_id:
                            type: string
                            format: uuid
                          status:
                            type: string
                        required:
                          - grant_id
                          - relation
                          - service_account_id
                          - project_id
                          - status
                      runtime_readiness:
                        type: object
                        properties:
                          status:
                            type: string
                            enum:
                              - ready
                              - offline
                              - not_applicable
                              - unknown
                          reason:
                            type:
                              - string
                              - 'null'
                          runtime_target_kind:
                            type:
                              - string
                              - 'null'
                            enum:
                              - registered_push_service
                              - pull_worker
                              - null
                          runtime_service_key:
                            type:
                              - string
                              - 'null'
                        required:
                          - status
                          - reason
                          - runtime_target_kind
                          - runtime_service_key
                      source_path:
                        type: string
                      edit_mode:
                        type: string
                        enum:
                          - structured
                          - source_only
                      avatar_url:
                        type:
                          - string
                          - 'null'
                        format: uri
                        description: >-
                          Absolute URL for this agent avatar. Null when no
                          custom avatar has been set.
                      x-veryfront-model:
                        type:
                          - string
                          - 'null'
                        description: Same value as model. Read model.
                      x-veryfront-url:
                        type: string
                        description: Same value as url. Read url.
                      model:
                        type:
                          - string
                          - 'null'
                        description: >-
                          Model the agent runs on. Null when the agent sets
                          none.
                      url:
                        type: string
                        description: URL of the agent.
                    required:
                      - id
                      - name
                      - description
                      - provider
                      - version
                      - capabilities
                      - default_input_modes
                      - default_output_modes
                      - tools
                      - skills
                      - kind
                      - can_run
                      - source_type
                      - source_path
                      - edit_mode
                      - x-veryfront-model
                      - x-veryfront-url
                      - model
                      - url
                  resolved_capabilities:
                    type: object
                    properties:
                      source_target:
                        type: object
                        properties:
                          kind:
                            type: string
                            enum:
                              - project
                              - main_branch
                              - environment
                              - preview_branch
                          target_environment_id:
                            type:
                              - string
                              - 'null'
                            format: uuid
                          target_branch_id:
                            type:
                              - string
                              - 'null'
                            format: uuid
                        required:
                          - kind
                          - target_environment_id
                          - target_branch_id
                      runtime_target:
                        type: object
                        properties:
                          kind:
                            type:
                              - string
                              - 'null'
                            enum:
                              - main_branch
                              - environment
                              - preview_branch
                              - null
                          target_environment_id:
                            type:
                              - string
                              - 'null'
                            format: uuid
                          target_branch_id:
                            type:
                              - string
                              - 'null'
                            format: uuid
                        required:
                          - kind
                          - target_environment_id
                          - target_branch_id
                      skills:
                        type: array
                        items:
                          oneOf:
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - project
                                id:
                                  type: string
                                name:
                                  type: string
                                description:
                                  type: string
                                source_path:
                                  type: string
                                edit_mode:
                                  type: string
                                  enum:
                                    - structured
                                    - source_only
                                allowed_tools:
                                  type: array
                                  items:
                                    type: string
                              required:
                                - type
                                - id
                                - name
                                - description
                                - source_path
                                - edit_mode
                              title: ProjectSkill
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - agent
                                id:
                                  type: string
                                name:
                                  type: string
                                description:
                                  type:
                                    - string
                                    - 'null'
                                tags:
                                  type: array
                                  items:
                                    type: string
                                examples:
                                  type: array
                                  items:
                                    type: string
                              required:
                                - type
                                - id
                                - name
                              title: AgentSkill
                      tools:
                        type: array
                        items:
                          oneOf:
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - control_plane
                                name:
                                  type: string
                                description:
                                  type: string
                                parameters:
                                  type: object
                                  additionalProperties: {}
                              required:
                                - type
                                - name
                              title: ControlPlaneTool
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - integration
                                name:
                                  type: string
                                description:
                                  type: string
                                input_schema:
                                  type: object
                                  additionalProperties: {}
                              required:
                                - type
                                - name
                                - description
                                - input_schema
                              title: IntegrationTool
                            - type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - project
                                id:
                                  type: string
                                name:
                                  type: string
                                description:
                                  type:
                                    - string
                                    - 'null'
                                source_path:
                                  type: string
                                edit_mode:
                                  type: string
                                  enum:
                                    - structured
                                    - source_only
                                input_schema:
                                  type:
                                    - object
                                    - 'null'
                                  additionalProperties: {}
                              required:
                                - type
                                - id
                                - name
                                - source_path
                                - edit_mode
                              title: ProjectTool
                      integrations:
                        type: array
                        items:
                          type: object
                          properties:
                            id:
                              type: string
                            name:
                              type: string
                            tool_names:
                              type: array
                              items:
                                type: string
                          required:
                            - id
                            - name
                            - tool_names
                      tool_resolution:
                        type: array
                        items:
                          type: object
                          properties:
                            tool_name:
                              type: string
                            source_selected:
                              type: boolean
                            catalog_available:
                              type: boolean
                            catalog_state:
                              type: string
                              enum:
                                - available
                                - removed
                            effective_authorization:
                              type: string
                              enum:
                                - authorized
                                - restricted_by_policy
                                - catalog_unavailable
                            policy:
                              type: object
                              properties:
                                state:
                                  type: string
                                  enum:
                                    - absent
                                    - allowed
                                    - restricted
                                scope:
                                  type: string
                                  enum:
                                    - project
                                    - user
                                allowed_tools:
                                  type:
                                    - array
                                    - 'null'
                                  items:
                                    type: string
                                execution_mode:
                                  type: string
                                  enum:
                                    - real
                                    - mock
                              required:
                                - state
                                - scope
                                - allowed_tools
                                - execution_mode
                            credential_requirement:
                              type: object
                              properties:
                                mode:
                                  type: string
                                  enum:
                                    - oauth_connection
                                    - project_credentials
                                    - none
                                managed_oauth:
                                  type: boolean
                                byo_oauth_app_override:
                                  type: object
                                  properties:
                                    supported:
                                      type: boolean
                                    required:
                                      type: boolean
                                    client_id_env_var:
                                      type:
                                        - string
                                        - 'null'
                                    client_secret_env_var:
                                      type:
                                        - string
                                        - 'null'
                                  required:
                                    - supported
                                    - required
                                    - client_id_env_var
                                    - client_secret_env_var
                                mandatory_env_vars:
                                  type: array
                                  items:
                                    type: string
                              required:
                                - mode
                                - managed_oauth
                                - byo_oauth_app_override
                                - mandatory_env_vars
                            connection_readiness:
                              type: object
                              properties:
                                status:
                                  type: string
                                  enum:
                                    - ready
                                    - required
                                    - not_applicable
                                    - unknown
                                scope:
                                  type:
                                    - string
                                    - 'null'
                                  enum:
                                    - project
                                    - user
                                    - null
                                connected_count:
                                  type:
                                    - integer
                                    - 'null'
                                  minimum: 0
                              required:
                                - status
                                - scope
                                - connected_count
                          required:
                            - tool_name
                            - source_selected
                            - catalog_available
                            - catalog_state
                            - effective_authorization
                            - policy
                            - credential_requirement
                            - connection_readiness
                      tool_access:
                        type: object
                        properties:
                          version:
                            type: number
                            enum:
                              - 1
                          freshness:
                            type: object
                            properties:
                              resolved_at:
                                type: string
                                format: date-time
                              valid_for_ms:
                                type: integer
                                exclusiveMinimum: 0
                              fail_closed_on_expiry:
                                type: boolean
                                enum:
                                  - true
                            required:
                              - resolved_at
                              - valid_for_ms
                              - fail_closed_on_expiry
                          inputs:
                            type: object
                            properties:
                              capabilities:
                                type: array
                                items:
                                  type: string
                                  enum:
                                    - project.read
                                    - project.settings.manage
                                    - project.delete
                                    - project.members.read
                                    - project.members.manage
                                    - project.invites.read
                                    - project.invites.manage
                                    - project.files.read
                                    - project.files.write
                                    - project.realtime.connect
                                    - project.realtime.write
                                    - project.files.admin
                                    - project.uploads.read
                                    - project.uploads.write
                                    - project.uploads.admin
                                    - project.knowledge.read
                                    - project.knowledge.write
                                    - project.releases.read
                                    - project.releases.write
                                    - project.deployments.read
                                    - project.deployments.write
                                    - project.deploy.execute
                                    - project.runtime.manage
                                    - project.channels.read
                                    - project.channels.write
                                    - project.sandboxes.manage
                                    - project.domains.write
                                    - project.environments.manage
                                    - project.env_vars.write
                                    - project.runs.read
                                    - project.runs.write
                                    - project.runs.admin
                                    - project.agents.read
                                    - project.agents.write
                                    - project.evals.read
                                    - project.evals.write
                                    - project.evals.run
                                    - project.conversations.read
                                    - project.conversations.write
                                    - project.conversations.create
                                    - project.integrations.read
                                    - project.integrations.connect
                                    - project.integrations.configure
                                    - project.api_keys.read
                                    - project.api_keys.manage
                                    - project.cache.read
                                    - project.cache.write
                                    - project.logs.read
                                    - project.metrics.read
                                    - project.resources.read
                              billing:
                                type: object
                                properties:
                                  collaboration_allowed:
                                    type: boolean
                                  can_invite:
                                    type: boolean
                                required:
                                  - collaboration_allowed
                                  - can_invite
                              entitlements:
                                type: object
                                properties:
                                  dedicated_runtime:
                                    type: boolean
                                  custom_domains:
                                    type: boolean
                                  export_apps:
                                    type: boolean
                                required:
                                  - dedicated_runtime
                                  - custom_domains
                                  - export_apps
                            required:
                              - capabilities
                              - billing
                              - entitlements
                          families:
                            type: array
                            items:
                              type: object
                              properties:
                                family:
                                  type: string
                                  enum:
                                    - collaboration
                                    - runtime
                                    - domains
                                    - export
                                default_decision:
                                  type: object
                                  properties:
                                    visibility:
                                      type: string
                                      enum:
                                        - visible
                                        - hidden
                                    reason_code:
                                      type: string
                                      enum:
                                        - allowed
                                        - missing_capability
                                        - billing_plan_restriction
                                        - billing_seat_limit
                                        - target_not_supported
                                        - resource_state_restriction
                                        - policy_exception
                                        - unknown
                                    message:
                                      type: string
                                  required:
                                    - visibility
                                    - reason_code
                                action_overrides:
                                  type: array
                                  items:
                                    type: object
                                    properties:
                                      action:
                                        type: string
                                        enum:
                                          - create_invite
                                          - delete_member
                                          - create_server
                                          - delete_server
                                          - create_domain
                                          - download_release
                                      decision:
                                        type: object
                                        properties:
                                          visibility:
                                            type: string
                                            enum:
                                              - visible
                                              - hidden
                                          reason_code:
                                            type: string
                                            enum:
                                              - allowed
                                              - missing_capability
                                              - billing_plan_restriction
                                              - billing_seat_limit
                                              - target_not_supported
                                              - resource_state_restriction
                                              - policy_exception
                                              - unknown
                                          message:
                                            type: string
                                        required:
                                          - visibility
                                          - reason_code
                                    required:
                                      - action
                                      - decision
                              required:
                                - family
                                - default_decision
                                - action_overrides
                        required:
                          - version
                          - freshness
                          - inputs
                          - families
                      prompts:
                        type: array
                        items:
                          type: object
                          properties:
                            id:
                              type: string
                            name:
                              type: string
                            description:
                              type:
                                - string
                                - 'null'
                            source_path:
                              type: string
                            edit_mode:
                              type: string
                              enum:
                                - structured
                                - source_only
                          required:
                            - id
                            - name
                            - source_path
                            - edit_mode
                      workflows:
                        type: array
                        items:
                          type: object
                          properties:
                            id:
                              type: string
                            name:
                              type: string
                            description:
                              type:
                                - string
                                - 'null'
                            target:
                              type: string
                            source_path:
                              type: string
                            edit_mode:
                              type: string
                              enum:
                                - structured
                                - source_only
                            version:
                              type:
                                - string
                                - 'null'
                            input_schema:
                              type:
                                - object
                                - 'null'
                              additionalProperties: {}
                            output_schema:
                              type:
                                - object
                                - 'null'
                              additionalProperties: {}
                            schedulable:
                              type: boolean
                          required:
                            - id
                            - name
                            - target
                            - source_path
                            - edit_mode
                            - schedulable
                      tasks:
                        type: array
                        items:
                          type: object
                          properties:
                            id:
                              type: string
                            name:
                              type: string
                            description:
                              type:
                                - string
                                - 'null'
                            target:
                              type: string
                            source_path:
                              type: string
                            edit_mode:
                              type: string
                              enum:
                                - structured
                                - source_only
                            input_schema:
                              type:
                                - object
                                - 'null'
                              additionalProperties: {}
                            output_schema:
                              type:
                                - object
                                - 'null'
                              additionalProperties: {}
                            schedulable:
                              type: boolean
                          required:
                            - id
                            - name
                            - target
                            - source_path
                            - edit_mode
                            - schedulable
                      diagnostics:
                        type: array
                        items:
                          type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - source_file_diagnostic
                                - source_agent_discovery_error
                                - source_trigger_discovery_error
                            source_kind:
                              type: string
                              enum:
                                - agent
                                - prompt
                                - tool
                                - task
                                - workflow
                                - resource
                                - skill
                                - eval
                                - schedule
                                - webhook
                            source_path:
                              type: string
                              minLength: 1
                            source_id:
                              type: string
                              minLength: 1
                            code:
                              type: string
                              enum:
                                - parse_error
                                - invalid_definition
                                - dynamic_definition
                                - duplicate_source_id
                                - unsupported_target
                                - manual_conflict
                            message:
                              type: string
                              minLength: 1
                            details:
                              type: object
                              additionalProperties: {}
                          required:
                            - kind
                            - source_kind
                            - source_path
                            - code
                            - message
                    required:
                      - source_target
                      - runtime_target
                      - skills
                      - tools
                      - integrations
                      - tool_access
                      - prompts
                      - workflows
                      - tasks
                required:
                  - agent
                  - resolved_capabilities
        '400':
          description: Bad request
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/Problem'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SourcePrimitiveErrorEnvelope'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SourcePrimitiveErrorEnvelope'
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SourcePrimitiveErrorEnvelope'
        '500':
          description: Server error
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/Problem'
        '503':
          description: >-
            internal: authentication state is temporarily unavailable and the
            request was not processed; retry shortly.
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/Problem'
components:
  parameters:
    ProjectReference:
      schema:
        $ref: '#/components/schemas/ProjectReference'
      required: true
      description: Project slug, UUID, or domain that identifies the project.
      name: project_reference
      in: path
  schemas:
    Problem:
      type: object
      properties:
        cause:
          type: string
          enum:
            - schedule_concurrency_forbidden
            - schedule_fire_in_progress
            - schedule_run_limit_reached
          description: Schedule admission refusal.
        idempotency:
          type: object
          properties:
            state:
              type: string
              enum:
                - in_progress
                - payload_mismatch
                - outcome_unknown
            operation:
              type: string
              minLength: 1
            retryable:
              type: boolean
            retry_after_seconds:
              type:
                - integer
                - 'null'
              minimum: 0
            expires_at:
              type:
                - string
                - 'null'
            recovery:
              type: object
              properties:
                available:
                  type: boolean
                description:
                  type: string
                resource_url:
                  type: string
              required:
                - available
                - description
          required:
            - state
            - operation
            - retryable
            - retry_after_seconds
            - expires_at
          description: Replay status, retry timing, and recovery lookup.
        type:
          type: string
          description: URI reference identifying the problem type
          example: https://api.veryfront.com/errors/validation-failed
        title:
          type: string
          description: Short human-readable summary of the problem
          example: Validation Failed
        status:
          type: integer
          minimum: 100
          maximum: 599
          description: HTTP status code
          example: 400
        code:
          type: string
          description: Stable machine-readable error code
          example: RUN_INVALID_INPUT
        detail:
          type: string
          description: Human-readable explanation specific to this occurrence
          example: The 'email' field must be a valid email address
        instance:
          type: string
          description: URI reference identifying the specific occurrence
          example: /projects/my-project/members
        slug:
          type: string
          description: Stable identifier for the problem type
          example: validation-failed
        category:
          type: string
          enum:
            - AUTH
            - RESOURCE
            - VALIDATION
            - DATABASE
            - SUBSCRIPTION
            - INTEGRATION
            - INTERNAL
          description: API error category
          example: VALIDATION
        suggestion:
          type: string
          description: Suggested action to resolve the problem
          example: >-
            Check the request body and query parameters against the API
            documentation.
        errors:
          type: array
          items:
            type: object
            properties:
              field:
                type: string
                description: Field path that caused the error
                example: email
              message:
                type: string
                description: Error message for this field
                example: Invalid email format
              code:
                type: string
                description: Error code for this field
                example: INVALID_FORMAT
            required:
              - field
              - message
          description: Detailed field-level errors for validation failures
      required:
        - type
        - title
        - status
    SourcePrimitiveErrorEnvelope:
      type: object
      properties:
        type:
          type: string
        title:
          type: string
        status:
          type: number
        detail:
          type: string
        error:
          type: string
        message:
          type: string
        edit_mode:
          type: string
          enum:
            - structured
            - source_only
        source_only_reasons:
          type: array
          items:
            type: string
        source_path:
          type: string
    ProjectReference:
      type: string
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT or API Key
      description: >-
        Use a JWT bearer token or a Veryfront API key in the `Authorization`
        header.
    apiKeyAuth:
      type: apiKey
      in: header
      name: X-API-Key
      description: Alternative API key header for `vf_<prefix>_<secret>` tokens.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.